Subject: Re: NNCP Services

From: Koushik Roy <[email-masked]>
Date: Sun, 10 Oct 2021 21:59:45 -0700

John Goerzen <[email-masked]> writes:

> On Fri, Oct 08 2021, Koushik Roy wrote:
>
>> Hey,
>>
>> I've been playing around with NNCP and really love what I'm 
>> finding so
>> far. I've built a whole bunch of stuff on NNCP so far, including
>> a youtube-dl based video downloader and a Telegram bot that lets 
>> me
>> send/receive messages through NNCP. (The latter bot was 
>> something I
>> cooked up for use on a trip where I was going to have low 
>> connectivity
>> and it worked really well.) I also use NNCP as a way to access 
>> services
>
> That is a really neat idea!  Do you happen to have the source code 
> for that available somewhere that the rest of us might try it out 
> too?

I just put some of the code on my Github. It's pretty raw, but should be
enough to get started with. I have the code for the send and receive
sides of the Telegram bot and the Youtube-dl downloader.

Youtube-dl Bot: https://github.com/Koshroy/yt-nncp
Telegram Receipt Relay Bot: https://github.com/Koshroy/telegram-nncp-bot
Telegram Send Relay Bot: https://github.com/Koshroy/telegram-send-bot

Feel free to let me know if you have any questions!

I have plans to convert the Telegram bot into a bot that uses an MDA to
actually relay received Telegram messages as mail, and then have a fake
MTA which parses incoming mail as messages to send out to Telegram. I'm
also planning on porting all of this to use the Matrix network as well,
but I have more friends/family on Telegram right now so that's what I'm
more interested in connecting first. I'm not super familiar with how
E-Mail works underneath so it's a bit of a learning experience for me.

>
>> and commands on my LAN at home, which I expose through a relay 
>> node with
>> an external static IPv4 IP. I was wondering if others had built 
>> any
>> services on NNCP and if so what other folks been doing and what 
>> patterns
>> they've been using?
>
> I've built an apt-offline processor, which is used to install or 
> upgrade Debian/ubuntu systems.
>
> On the Internet-connected box, I have an exec:
>
>         apt-offline: ["/usr/local/bin/apt-offline-proc"]
>
> The script can just run apt-offline get $INPUTFILE --bundle 
> $OUTPUTFILE
> then use nncp-file to send the OUTPUTFILE to $NNCP_SENDER

Oh isn't this a bit dangerous? I've never used a flow like this so I'm
not sure, but isn't it a bit scary to apply package/system updates
completely unattended like this?

>
> I also have scripts for receiving zfs or dar backups, and for 
> distributed syncing of git repos.  See 
> https://changelog.complete.org/archives/tag/nncp for details.
>
> I also run Usenet over NNCP, and offer NNCP Usenet feeds to 
> interested people.

Oh, I might be interested in an NNCP Usenet feed!

Also, is there any group of folks exchanging mail over NNCP? I realize
that with this mailing list there might not be much of a need, but it
would be cool to exchange mail over NNCP! I've been wiring up a local
Postfix MTA to NNCP for use between machines of mine.

Thanks,
Koushik